diff -r -u qmail-1.03-orig/qmail-send.c qmail-1.03/qmail-send.c
--- qmail-1.03-orig/qmail-send.c	Mon Jun 15 10:53:16 1998
+++ qmail-1.03/qmail-send.c	Tue Feb 18 19:03:32 2003
@@ -1,5 +1,7 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <stdio.h>
+#include <stdlib.h>
 #include "readwrite.h"
 #include "sig.h"
 #include "direntry.h"
@@ -661,6 +663,8 @@
  static stralloc quoted = {0};
  datetime_sec birth;
  unsigned long qp;
+ unsigned long random;
+ unsigned char randoms[100];
 
  if (!getinfo(&sender,&birth,id)) return 0; /* XXX: print warning */
 
@@ -692,6 +696,8 @@
    if (*sender.s) { bouncesender = ""; bouncerecip = sender.s; }
    else { bouncesender = "#@[]"; bouncerecip = doublebounceto.s; }
 
+   random = rand();
+   sprintf(randoms, "qrfm-%d", random);
    while (!newfield_datemake(now())) nomem();
    qmail_put(&qqt,newfield_date.s,newfield_date.len);
    qmail_puts(&qqt,"From: ");
@@ -704,6 +710,17 @@
    qmail_put(&qqt,quoted.s,quoted.len);
    qmail_puts(&qqt,"\n\
 Subject: failure notice\n\
+MIME-Version: 1.0\n\
+Content-Type: multipart/mixed; boundary=\"");
+   qmail_puts(&qqt,randoms);
+   qmail_puts(&qqt,"\"\n\
+\n\
+This is a multi-part message in MIME format.\n\
+\n\
+--");
+   qmail_puts(&qqt,randoms);
+   qmail_puts(&qqt,"\n\
+Content-Type: text/plain\n\
 \n\
 Hi. This is the qmail-send program at ");
    qmail_put(&qqt,bouncehost.s,bouncehost.len);
@@ -729,7 +746,14 @@
        qmail_fail(&qqt);
     }
 
-   qmail_puts(&qqt,*sender.s ? "--- Below this line is a copy of the message.\n\n" : "--- Below this line is the original bounce.\n\n");
+   qmail_puts(&qqt,*sender.s ? "--- Attached is a copy of the message.\n" : "--- Attached is the original bounce.\n");
+
+   qmail_puts(&qqt,"--");
+   qmail_puts(&qqt,randoms);
+   qmail_puts(&qqt,"\n\
+Content-Type: message/rfc822\n\
+Content-Disposition: attachment\n\
+\n");
    qmail_puts(&qqt,"Return-Path: <");
    while (!quote2(&quoted,sender.s)) nomem();
    qmail_put(&qqt,quoted.s,quoted.len);
@@ -748,6 +772,10 @@
        qmail_fail(&qqt);
     }
 
+   qmail_puts(&qqt,"\n--");
+   qmail_puts(&qqt,randoms);
+   qmail_puts(&qqt,"--\n");
+
    qmail_from(&qqt,bouncesender);
    qmail_to(&qqt,bouncerecip);
    if (*qmail_close(&qqt))
@@ -1522,6 +1550,7 @@
  struct timeval tv;
  int c;
 
+ srand(time(0));
  if (chdir(auto_qmail) == -1)
   { log1("alert: cannot start: unable to switch to home directory\n"); _exit(111); }
  if (!getcontrols())
